#ifndef _InternalRayCaster_H__
#define _InternalRayCaster_H__

#include "RayCaster.h"
#include "Containers.h"
#include <string>
using namespace std;


namespace GtpVisibilityPreprocessor {


class Intersectable;
class VssRay;
class KdTree;
class Ray;
class SimpleRayContainer;
class AxisAlignedBox3;
class Vector3;
struct VssRayContainer;
class Preprocessor;



/** This class provides an interface for ray casting.
*/
class InternalRayCaster: public RayCaster
{
public:
	/** Default constructor initialising e.g., KD tree
	*/
	InternalRayCaster(const Preprocessor &preprocessor, KdTree *kdTree);
	virtual ~InternalRayCaster();

	int Type() const { return INTERNAL_RAYCASTER; }

	virtual int CastRay(
		const Vector3 &viewPoint,
		const Vector3 &direction,
		const float probability,
        VssRayContainer &vssRays,
		const AxisAlignedBox3 &box,
		const bool castDoubleRay
		);

	 virtual void CastRays16(
		 const int i,
		 SimpleRayContainer &rays, 
		 VssRayContainer &vssRays,
		 const AxisAlignedBox3 &sbox,
		 const bool castDoubleRay
		 );

protected:

	KdTree *mKdTree;
};


}

#endif
